YssDarkPact = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "Sink-1.0")

local YDP_enable
local YDP_rank
local YLT_enable
local YLT_rank
local YLT_talent
local YDP_last_update = 0

function YssDarkPact:OnEnable()
	local _, Class = UnitClass("player")
	if Class == "WARLOCK" then
		local i = 1
		local _, _, offset, numSpells = GetSpellTabInfo(2);
		for s = offset + 1, offset + numSpells do
			local	spellName, spellRank = GetSpellName(s, BOOKTYPE_SPELL);
			if spellName == "Dark Pact" then
				YDP_enable = true
				if spellRank == 'Rank 1' then
					YDP_rank = 305
				elseif spellRank == 'Rank 2' then
					YDP_rank = 440
				elseif spellRank == 'Rank 3' then
					YDP_rank = 545
				elseif spellRank == 'Rank 4' then
					YDP_rank = 700
				end
			end
			if spellName == "Life Tap" then
				YLT_enable = true
				if spellRank == 'Rank 1' then
					YLT_rank = 20
				elseif spellRank == 'Rank 2' then
					YLT_rank = 65
				elseif spellRank == 'Rank 3' then
					YLT_rank = 130
				elseif spellRank == 'Rank 4' then
					YLT_rank = 210
				elseif spellRank == 'Rank 5' then
					YLT_rank = 300
				elseif spellRank == 'Rank 6' then
					YLT_rank = 420
				elseif spellRank == 'Rank 7' then
					YLT_rank = 580
				end
			end
		end
		local _, _, _, _, currentRank = GetTalentInfo(1, 5)
		YLT_talent = ((currentRank * 10) + 100) / 100
		if YLT_enable then
			self:RegisterEvent("UNIT_MANA")
		end
	end
end

function YssDarkPact:UNIT_MANA(arg1)
	if arg1 == "pet" or arg1 == "player" then
		local YDP_stamp = GetTime()
		if YDP_stamp - YDP_last_update > 5 then
			if not YDP_enable then
				if (UnitManaMax("player") - UnitMana("player") > (YLT_rank + (GetSpellBonusDamage(6) * .80)) * YLT_talent) and (UnitHealth("player") > UnitHealthMax("player")-UnitHealth("player")) and (UnitHealth("player") > YLT_rank + (GetSpellBonusDamage(6) * .80)) then
					self:Pour("Life Tap now!", 1, 0, 0, nil, 24, "OUTLINE", true)
					YDP_last_update = YDP_stamp
					return;
				end
			else
				if UnitManaMax("player") - UnitMana("player") > YDP_rank + (GetSpellBonusDamage(6) * .96) then
					if UnitMana("pet") >= YDP_rank + (GetSpellBonusDamage(6) * .96) then
						self:Pour("Dark Pact now!", 1, 0, 0, nil, 24, "OUTLINE", true)
						YDP_last_update = YDP_stamp
						return;
					else
						if (UnitManaMax("player") - UnitMana("player") > (YLT_rank + (GetSpellBonusDamage(6) * .80)) * YLT_talent) and (UnitHealth("player") > UnitHealthMax("player")-UnitHealth("player")) and (UnitHealth("player") > YLT_rank + (GetSpellBonusDamage(6) * .80)) then
							self:Pour("Life Tap now!", 1, 0, 0, nil, 24, "OUTLINE", true)
							YDP_last_update = YDP_stamp
							return;
						end
					end
				end
			end
		end
	end
end
